from multiprocessing.pool import Pool
import matplotlib.pyplot as plt
import numpy as np
from Calc_z_NormalDistri import calc_z
from grid import *

if __name__ == '__main__':
    nm_f_in = input('Input data file name = ')
    f_in = open(nm_f_in, 'r')

    nm_f_out = input('Output file name = ')
    f_out = open(nm_f_out, 'w')
    f_out.write('Data file = {}\n'.format(nm_f_in))

    Data_f = f_in.readlines()
    f_in.close()
 
    pos = 0
    while True:
        if len(Data_f[pos]) > 0:
            if Data_f[pos][0] == '/':
                pos += 1
                break
        pos += 1

    N_Vars = int(Data_f[pos])
    print('Number of variables = ', N_Vars)

    pos += 1
    while True:
        if len(Data_f[pos]) > 0:
            if Data_f[pos][0] == '/':
                pos += 1
                break
        pos += 1

    Ks = []
    strs = Data_f[pos].split()
    for s in strs:
        Ks.append(int(s))
    print('Ks = ', Ks)

    pos += 1
    while True:
        if len(Data_f[pos]) > 0:
            if Data_f[pos][0] == '/':
                pos += 1
                break
        pos += 1

    IDs = []
    strs = Data_f[pos].split()
    for i in range(N_Vars):
        IDs.append(strs[i + 1])
    print('IDs = ', IDs)
    

    pos += 1
    while True:
        if len(Data_f[pos]) > 0:
            if Data_f[pos][0] == '/':
                pos += 1
                break
        pos += 1

    Xs = []
    n = 0
    while True:
        strs = Data_f[pos].split()
        Xs.append([])
        for i in range(N_Vars):
            Xs[n].append(int(strs[i + 1]))
        n += 1
        pos += 1
        if Data_f[pos][0] == '/':
            break

    i = 0
    for v in Xs:
        if (i < 10) or (i > n - 10):
            print('{0}:  '.format(i), v)
        i += 1

    Rs = []
    for ix1 in range(N_Vars):
        Rs.append([])
        for ix2 in range(N_Vars):
            Rs[ix1].append(0.0)
            
    for ix1 in range(N_Vars):
        for ix2 in range(ix1, N_Vars):
            print('\nEstimatin for Var-{0} and Var-{1} started.\n'.format(ix1, ix2))
            f_out.write('\n\nEstimatin for {0} and {1}\n'.format(IDs[ix1], IDs[ix2]))
            
            if ix1 == ix2:
                Rs[ix1][ix1] = 1.0
            else:
                Kx = Ks[ix1]
                Ky = Ks[ix2]
                V_IDx = IDs[ix1]
                V_IDy = IDs[ix2]
                X = []
                for i in range(n):
                    X.append([])
                    X[i].append(Xs[i][ix1])
                    X[i].append(Xs[i][ix2])

                print('\nKx = {0}   Ky = {1}'.format(Kx, Ky))
                print('V_IDx = {0}   V_IDy = {1}'.format(V_IDx, V_IDy))

                FreqX = []
                for i in range(Kx):
                    FreqX.append(0)
                FreqY = []
                for i in range(Ky):
                    FreqY.append(0)
                for i in range(n):
                    FreqX[X[i][0] - 1] += 1
                    FreqY[X[i][1] - 1] += 1

                print('\nFreqX = \n', FreqX)
                print('\nFreqY = \n', FreqY)

                CumFreqX = []
                CumPropX = []
                for k in range(Kx):
                    if k == 0:
                        CumFreqX.append(FreqX[0])
                        CumPropX.append(FreqX[0] / n)
                    else:
                        CumFreqX.append(FreqX[k] + CumFreqX[k - 1])
                        CumPropX.append(CumFreqX[k] / n)

                print('\nCumFreqX = ', CumFreqX)
                print('CumPropX = ', CumPropX)
                    
                CumFreqY = []
                CumPropY = []
                for k in range(Ky):
                    if k == 0:
                        CumFreqY.append(FreqY[0])
                        CumPropY.append(FreqY[0] / n)
                    else:
                        CumFreqY.append(FreqY[k] + CumFreqY[k - 1])
                        CumPropY.append(CumFreqY[k] / n)

                print('\nCumFreqY = ', CumFreqY)
                print('CumPropY = ', CumPropY)

                Cx = []
                for k in range(Kx - 1):
                    Cx.append(calc_z(CumPropX[k]))

                Cy = []
                for k in range(Ky - 1):
                    Cy.append(calc_z(CumPropY[k]))

                print('\nCx = ', Cx)
                print('\nCy = ', Cy)

                f_out.write('\nCx = {}\n'.format(Cx))
                f_out.write('\nCy = {}\n'.format(Cy))

                Nij = []
                for i in range(Kx):
                    Nij.append([])
                    for j in range(Ky):
                        Nij[i].append(0)
                for i in range(n):
                    Nij[X[i][0] - 1][X[i][1] - 1] += 1

                print('\nNij = \n', Nij)



                grid_x = []
                for i in range(-999, 1000):
                    grid_x.append(i / 1000)

                grid_len = len(grid_x)



                params = {'Msg': 'Calculation for Var-{0} and Var-{1}'.format(ix1, ix2),
                          'Nij': Nij, 'Kx': Kx,  'Ky': Ky, 'Cx': Cx, 'Cy': Cy,
                          'grid_x': grid_x, 'p_start': 0, 'p_end': len(grid_x) - 1 }

                n_mcmc = 4
                ary_params = []
                for i in range(n_mcmc):
                    temp = params.copy()
                    if i < (n_mcmc - 1):
                        temp['p_start'] = i * (grid_len // n_mcmc)
                        temp['p_end'] = (i + 1) * (grid_len // n_mcmc) - 1
                    else:
                        temp['p_start'] = (n_mcmc - 1) * (grid_len // n_mcmc)
                        temp['p_end'] = grid_len - 1
                    ary_params.append(temp)
                    

                pool = Pool()
                print('Calculation of grid values started.')
                results = pool.map(EstGrid, ary_params)
                print('Calculation of grid values ended.')
                
                grid_Log_p = []
                for v in results:
                    grid_Log_p += v

                ck_v = grid_Log_p[0]
                for v in grid_Log_p:
                    if ck_v < v:
                        ck_v = v

                grid_p = []
                for v in grid_Log_p:
                    grid_p.append(math.exp(v - ck_v))
               
                sum = np.sum(grid_p)
                print('sum = ', sum)
                grid_p_adj = []
                for v in grid_p:
                    grid_p_adj.append(v / sum)
                
                t_map = np.argmax(grid_p_adj)
                print('t_map = ', t_map)
                MAP = grid_x[t_map]
                print('\nMAP = ', MAP)    
                f_out.write('\nMAP estimate of rho = {0:.3}\n'.format(MAP))
                

                ipos1 = 0
                sum1 = 0.0
                while True:
                    sum1 += grid_p_adj[ipos1]
                    if sum1 > 0.025:
                        break
                    ipos1 += 1
                ipos0 = ipos1 - 1
                sum0 = sum1 - grid_p_adj[ipos1]
                p025 = (grid_x[ipos0] * (sum1 - 0.025) + grid_x[ipos1] * (0.025 - sum0)) /\
                      grid_p_adj[ipos1]
                ipos1 = len(grid_x) - 1
                sum1 = 0.0
                while True:
                    sum1 += grid_p_adj[ipos1]
                    if sum1 > 0.025:
                        break
                    ipos1 -= 1
                ipos0 = ipos1 + 1
                sum0 = sum1 - grid_p_adj[ipos1]
                p975 = (grid_x[ipos1] * (0.025 - sum0) + grid_x[ipos0] * (sum1 - 0.025)) /\
                       grid_p_adj[ipos1]

                print('\n95% CI = [{0:.3}, {1:.3}]\n'.format(p025, p975))
                f_out.write('\n95% CI = [{0:.3}, {1:.3}]\n'.format(p025, p975))
        
                v = 0.0
                for i in range(len(grid_x)):
                    v += grid_x[i] * grid_p_adj[i]
                mean = v
                v = 0.0
                for i in range(len(grid_x)):
                    v += ((grid_x[i] - mean) ** 2) * grid_p_adj[i]
                sd = v ** 0.5

                print('mean = {0:.3}     sd = {1:.3}'.format(mean, sd))
                f_out.write('\nmean = {0:.3}     sd = {1:.3}\n'.format(mean, sd))

                Rs[ix1][ix2] = Rs[ix2][ix1] = MAP   
                
                
 
    f_out.write('\n\nMAP estimates of rhos...\n')
    for ix1 in range(N_Vars):
        for ix2 in range(N_Vars):
            f_out.write("{0:>10.3}".format(Rs[ix1][ix2]))
        f_out.write('\n')

    f_out.close()
    print(nm_f_out + ' was saved.')
    print()
